//+------------------------------------------------------------------+
//|                                                  Ambush_Fibs.mq4 |
//|                                           kris.pivo[at]gmail.com |
//|          Based on David Willis' TheOnlyPivot_multi.mq4 indicator |
//|                        Enhanced for multi-timeframes by Linuxser |
//+------------------------------------------------------------------+
#property copyright " Kris, 2008"
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 DarkGreen
#property indicator_color2 Green
#property indicator_color3 LimeGreen
#property indicator_color4 Yellow
#property indicator_color5 Yellow
#property indicator_color6 Red
#property indicator_color7 Crimson
#property indicator_color8 Maroon

//---- input parameters
extern int JP_open =  0; // the Hour to Start
extern int EU_open =  8;
extern int US_open = 13;

//---- buffers
double ExtBuffer0[];  // Fibonacci Extension +1.618
double ExtBuffer1[];  // Fibonacci Extension +1.272
double ExtBuffer2[];  // Previous Session High
double ExtBuffer3[];  // Fibonacci 0.618
double ExtBuffer4[];  // Fibonacci 0.382
double ExtBuffer5[];  // Previous Session Low
double ExtBuffer6[];  // Fibonacci Extension -1.272
double ExtBuffer7[];  // Fibonacci Extension -1.618
int    DataPeriod;
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE, STYLE_DOT, 1);  // Long Profit Target 3 - Fibonacci 1.618 extension
   SetIndexBuffer(0,ExtBuffer0);
   SetIndexLabel(0,"Fibonacci Extension +1.618");
   
   SetIndexStyle(1,DRAW_LINE, STYLE_DOT, 1);  // Long Profit Target 2 - Fibonacci 1.272 extension
   SetIndexBuffer(1,ExtBuffer1);
   SetIndexLabel(1,"Fibonacci Extension +1.272"); 
   
   SetIndexStyle(2,DRAW_LINE, STYLE_DOT, 1);  // Long Profit Target 1 - Previous Session High - Fibonacci 1.000 
   SetIndexBuffer(2,ExtBuffer2);
   SetIndexLabel(2,"Previous Session High"); 

   SetIndexStyle(3,DRAW_LINE, STYLE_DOT, 1);  // LONG ENTRY - Fibonacci 0.618
   SetIndexBuffer(3,ExtBuffer3);
   SetIndexLabel(3,"Fibonacci 0.618"); 
   
   SetIndexStyle(4,DRAW_LINE, STYLE_DOT, 1);    // SHORT ENTRY - Fibonacci 0.382
   SetIndexBuffer(4,ExtBuffer4);
   SetIndexLabel(4,"Fibonacci 0.382"); 
   
   SetIndexStyle(5,DRAW_LINE, STYLE_DOT, 1);    // Short Profit Target 1 - Previous Session Low
   SetIndexBuffer(5,ExtBuffer5);
   SetIndexLabel(5,"Previous Session Low"); 

   SetIndexStyle(6,DRAW_LINE, STYLE_DOT, 1);    // Short Profit Target 2 - Fibonacci 1.272 extension
   SetIndexBuffer(6,ExtBuffer6);
   SetIndexLabel(6,"Fibonacci Extension -1.272"); 
   
   SetIndexStyle(7,DRAW_LINE, STYLE_DOT, 1);    // Short Profit Target 3 - Fibonacci 1.618 extension
   SetIndexBuffer(7,ExtBuffer7);
   SetIndexLabel(7,"Fibonacci Extension -1.618"); 
   
   switch(Period())
   {
      case PERIOD_D1:  DataPeriod = 1;    break;
      case PERIOD_H4:  DataPeriod = 6;    break;
      case PERIOD_H1:  DataPeriod = 24;   break;  
      case PERIOD_M30: DataPeriod = 48;   break;   
      case PERIOD_M15: DataPeriod = 96;   break;
      case PERIOD_M5:  DataPeriod = 288;  break;
      case PERIOD_M1:  DataPeriod = 1440; break;
  
   }
   
   return(0);
  }
  
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
int session(int i)
{
 int hour=TimeHour(iTime(NULL,0,i));
 int session=0;
   // Find Session: 1=Tokyo, 2=London, 3=NYC
      
      if(JP_open < EU_open)
      {
      if(hour>=JP_open && hour<EU_open){session=1;}
      }
      else
      {
      if(hour>=JP_open || hour<EU_open){session=1;}
      }
      if(EU_open < US_open)
      {
      if(hour>=EU_open && hour<US_open){session=2;}
      }
      else
      {
      if(hour>=EU_open || hour<US_open){session=2;}
      }
      if(US_open < JP_open)
      {
      if(hour>=US_open && hour<JP_open){session=3;}
      }
      else
      {
      if(hour>=US_open || hour<JP_open){session=3;}
      }
      
 return(session);
 }    
  
int start()
  {
     if(Period() > 240)
     {
     Print("Error - Chart period is greater than 1 day.");
     return(-1); // then exit
     }
     
     double PreviousSessionHigh, PreviousSessionLow;
     double Fib0618, Fib0382;
     double FibExtP1272, FibExtP1618;
     double FibExtN1272, FibExtN1618;
     int high,low,close;
     int startime,start,end,hour,cnt,session;
     int counted_bars=IndicatorCounted();
  //---- check for possible errors
     if(counted_bars<0) return(-1);
  //---- the last counted bar will be recounted
     int limit = Bars-counted_bars;
     if(limit>Bars-DataPeriod){limit=Bars-DataPeriod;}
  //---- main loop
     for (int i=limit; i >= 0; i--)
     {
      session=session(i);
   
     if(session==1)
     {
      for(cnt=i;session(cnt)!=2;cnt++)
      {
       if(session(cnt)==3)
       {
        if(session(cnt-1)==1)
        {
         close=cnt;
         high=cnt;
         low=cnt;
        }
        if(High[cnt]>High[high]){high=cnt;}
        if(Low[cnt]<Low[low]){low=cnt;}
       } } }
     
     if(session==2)
     {
      for(cnt=i;session(cnt)!=3;cnt++)
      {
       if(session(cnt)==1)
       {
        if(session(cnt-1)==2)
        {
         close=cnt;
         high=cnt;
         low=cnt;         
        }
        if(High[cnt]>High[high]){high=cnt;}
        if(Low[cnt]<Low[low]){low=cnt;}
       } } }
     
     if(session==3)
     {
      for(cnt=i;session(cnt)!=1;cnt++)
      {
       if(session(cnt)==2)
       {
        if(session(cnt-1)==3)
        {
         close=cnt;
         high=cnt;
         low=cnt;
        }
        if(High[cnt]>High[high]){high=cnt;}
        if(Low[cnt]<Low[low]){low=cnt;}
       } } }
     
     FibExtP1618 = High[high] + (High[high]-Low[low]) * 0.618;
     FibExtP1272 = High[high] + (High[high]-Low[low]) * 0.272;
     PreviousSessionHigh = High[high];
     Fib0618     = Low[low]   + (High[high]-Low[low]) * 0.618;
     Fib0382     = Low[low]   + (High[high]-Low[low]) * 0.382;
     PreviousSessionLow  = Low[low];
     FibExtN1272 = Low[low] - (High[high]-Low[low]) * 0.272;
     FibExtN1618 = Low[low] - (High[high]-Low[low]) * 0.618;
     
     ExtBuffer0[i]=FibExtP1618; 
     ExtBuffer1[i]=FibExtP1272;
     ExtBuffer2[i]=PreviousSessionHigh;
     ExtBuffer3[i]=Fib0618;
     ExtBuffer4[i]=Fib0382;
     ExtBuffer5[i]=PreviousSessionLow;
     ExtBuffer6[i]=FibExtN1272;
     ExtBuffer7[i]=FibExtN1618;
    }   
     return(0);
    }
//+---------------------------------------------------------------------------+
//|                              THE END                                      |
//+---------------------------------------------------------------------------+